/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
// disable data conversion warnings

#pragma warning(disable : 4244)     // MIPS
#pragma warning(disable : 4136)     // X86
#pragma warning(disable : 4051)     // ALPHA
  
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>

#define strncasecmp strnicmp

void GL_BeginRendering (void);
void GL_EndRendering (void);

extern	int		texture_mode;

int GL_LoadTexture (char *identifier, int width, int height, byte *data, qboolean mipmap, qboolean alpha, int bytesperpixel);

// r_local.h -- private refresh defs

#define ALIAS_BASE_SIZE_RATIO		(0.0909090909)
					// normalizing factor so player model works out to about
					//  1 pixel per triangle
#define	MAX_LBM_HEIGHT		1024

#define BACKFACE_EPSILON	0.01

void R_TimeRefresh_f (void);
texture_t *R_TextureAnimation (texture_t *base);

//====================================================

extern	entity_t	r_worldentity;
extern	vec3_t		modelorg;
extern	entity_t	*currententity;
extern	int			r_visframecount;	// ??? what difs?
extern	int			r_framecount;
extern	mplane_t	frustum[4];
extern	int			c_brush_polys, c_alias_polys;

//
// view origin
//
extern	vec3_t	vup;
extern	vec3_t	vpn;
extern	vec3_t	vright;
extern	vec3_t	r_origin;

//
// screen size info
//
extern	mleaf_t		*r_viewleaf, *r_oldviewleaf;
extern	texture_t	*r_notexture_mip;
extern	int			d_lightstylevalue[256];	// 8.8 fraction of base light value

extern	cvar_t	r_norefresh;
extern	cvar_t	r_speeds;
extern	cvar_t	r_wateralpha;
extern	cvar_t	r_dynamic;
extern	cvar_t	r_novis;

extern	cvar_t	gl_clear;
extern	cvar_t	gl_poly;
extern	cvar_t	gl_keeptjunctions;

extern	int		gl_solid_format;
extern	int		gl_alpha_format;

extern	cvar_t	gl_max_size;

extern	cvar_t	slowmo;		// Tomaz - Slowmo

// Tomaz - Fog Begin
extern  cvar_t  gl_fogenable; 
extern  cvar_t  gl_fogstart;
extern  cvar_t  gl_fogend; 
extern  cvar_t  gl_fogred; 
extern  cvar_t  gl_fogblue; 
extern  cvar_t  gl_foggreen; 
// Tomaz - Fog End

extern  cvar_t  show_fps;		// Tomaz - FPS Counter
extern  cvar_t  skybox_spin;	// Tomaz - Spinning Skyboxes

extern	float	r_world_matrix[16];

typedef void (APIENTRY *lpMTexFUNC)		(GLenum, GLfloat, GLfloat);
typedef void (APIENTRY *lpSelTexFUNC)	(GLenum);
extern	lpMTexFUNC		MTexCoord2f;
extern	lpSelTexFUNC	SelectTexture;

void EmitWaterPolys		(msurface_t *s);

void R_DrawSkyBox (void);
qboolean R_CullBox(vec3_t mins, vec3_t maxs);
void R_MarkLights(dlight_t *light, int bit, mnode_t *node);
void R_StoreEfrags(efrag_t **ppefrag);