/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#include "quakedef.h"
#include "winquake.h"
#include "menu.h"

/*
=========
Main Menu
=========
*/

int m_save_demonum;

int	main_cursor;
#define	MAIN_ITEMS	4

void M_Menu_Main_f (void)
{
	if (key_dest != key_menu)
	{
		m_save_demonum = cls.demonum;
		cls.demonum = -1;
	}
	key_dest = key_menu;
	m_state = m_main;
	m_entersound = true;
}

void M_Main_Draw (void)
{
	M_Print (16, 16,	"Main Menu");

	M_Print (16, 48,	"Single Player");
	M_Print (16, 64,	"MultiPlayer");
	M_Print (16, 80,	"Options");
	M_Print (16, 96,	"Quit");

	M_DrawCharacter (0, 48 + main_cursor*16, 12+((int)(realtime*4)&1));
}

void M_Main_Key (int key)
{
	switch (key)
	{
	case K_ESCAPE:
		key_dest = key_game;
		m_state = m_none;
		cls.demonum = m_save_demonum;
		if (cls.demonum != -1 && !cls.demoplayback && cls.state != ca_connected)
			CL_NextDemo ();
		break;

	case K_DOWN:
		S_LocalSound ("misc/menu1.wav");
		if (++main_cursor >= MAIN_ITEMS)
			main_cursor = 0;
		break;

	case K_UP:
		S_LocalSound ("misc/menu1.wav");
		if (--main_cursor < 0)
			main_cursor = MAIN_ITEMS - 1;
		break;

	case K_ENTER:
		m_entersound = true;

		switch (main_cursor)
		{
		case 0:
			M_Menu_SinglePlayer_f ();
			break;

		case 1:
			M_Menu_MultiPlayer_f ();
			break;

		case 2:
			M_Menu_Options_f ();
			break;

		case 3:
			Host_Quit_f ();
			break;
		}
	}
}